// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package factory

import (
	"context"

	models "github.com/AlienList/backend-watchlist/bob"
	"github.com/aarondl/opt/omit"
	"github.com/google/uuid"
	"github.com/jaswdr/faker"
	"github.com/stephenafamo/bob"
)

type UserMod interface {
	Apply(*UserTemplate)
}

type UserModFunc func(*UserTemplate)

func (f UserModFunc) Apply(n *UserTemplate) {
	f(n)
}

type UserModSlice []UserMod

func (mods UserModSlice) Apply(n *UserTemplate) {
	for _, f := range mods {
		f.Apply(n)
	}
}

// UserTemplate is an object representing the database table.
// all columns are optional and should be set by mods
type UserTemplate struct {
	UserID       func() uuid.UUID
	Username     func() string
	Passwordhash func() string

	r userR
	f *Factory
}

type userR struct {
	Watchlists []*userRWatchlistsR
}

type userRWatchlistsR struct {
	number int
	o      *WatchlistTemplate
}

// Apply mods to the UserTemplate
func (o *UserTemplate) Apply(mods ...UserMod) {
	for _, mod := range mods {
		mod.Apply(o)
	}
}

// toModel returns an *models.User
// this does nothing with the relationship templates
func (o UserTemplate) toModel() *models.User {
	m := &models.User{}

	if o.UserID != nil {
		m.UserID = o.UserID()
	}
	if o.Username != nil {
		m.Username = o.Username()
	}
	if o.Passwordhash != nil {
		m.Passwordhash = o.Passwordhash()
	}

	return m
}

// toModels returns an models.UserSlice
// this does nothing with the relationship templates
func (o UserTemplate) toModels(number int) models.UserSlice {
	m := make(models.UserSlice, number)

	for i := range m {
		m[i] = o.toModel()
	}

	return m
}

// setModelRels creates and sets the relationships on *models.User
// according to the relationships in the template. Nothing is inserted into the db
func (t UserTemplate) setModelRels(o *models.User) {
	if t.r.Watchlists != nil {
		rel := models.WatchlistSlice{}
		for _, r := range t.r.Watchlists {
			related := r.o.toModels(r.number)
			for _, rel := range related {
				rel.UserID = o.UserID
				rel.R.User = o
			}
			rel = append(rel, related...)
		}
		o.R.Watchlists = rel
	}

}

// BuildSetter returns an *models.UserSetter
// this does nothing with the relationship templates
func (o UserTemplate) BuildSetter() *models.UserSetter {
	m := &models.UserSetter{}

	if o.UserID != nil {
		m.UserID = omit.From(o.UserID())
	}
	if o.Username != nil {
		m.Username = omit.From(o.Username())
	}
	if o.Passwordhash != nil {
		m.Passwordhash = omit.From(o.Passwordhash())
	}

	return m
}

// BuildManySetter returns an []*models.UserSetter
// this does nothing with the relationship templates
func (o UserTemplate) BuildManySetter(number int) []*models.UserSetter {
	m := make([]*models.UserSetter, number)

	for i := range m {
		m[i] = o.BuildSetter()
	}

	return m
}

// Build returns an *models.User
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use UserTemplate.Create
func (o UserTemplate) Build() *models.User {
	m := o.toModel()
	o.setModelRels(m)

	return m
}

// BuildMany returns an models.UserSlice
// Related objects are also created and placed in the .R field
// NOTE: Objects are not inserted into the database. Use UserTemplate.CreateMany
func (o UserTemplate) BuildMany(number int) models.UserSlice {
	m := make(models.UserSlice, number)

	for i := range m {
		m[i] = o.Build()
	}

	return m
}

func ensureCreatableUser(m *models.UserSetter) {
	if m.Username.IsUnset() {
		m.Username = omit.From(random[string](nil))
	}
	if m.Passwordhash.IsUnset() {
		m.Passwordhash = omit.From(random[string](nil))
	}
}

// insertOptRels creates and inserts any optional the relationships on *models.User
// according to the relationships in the template.
// any required relationship should have already exist on the model
func (o *UserTemplate) insertOptRels(ctx context.Context, exec bob.Executor, m *models.User) (context.Context, error) {
	var err error

	if o.r.Watchlists != nil {
		for _, r := range o.r.Watchlists {
			var rel0 models.WatchlistSlice
			ctx, rel0, err = r.o.createMany(ctx, exec, r.number)
			if err != nil {
				return ctx, err
			}

			err = m.AttachWatchlists(ctx, exec, rel0...)
			if err != nil {
				return ctx, err
			}
		}
	}

	return ctx, err
}

// Create builds a user and inserts it into the database
// Relations objects are also inserted and placed in the .R field
func (o *UserTemplate) Create(ctx context.Context, exec bob.Executor) (*models.User, error) {
	_, m, err := o.create(ctx, exec)
	return m, err
}

// create builds a user and inserts it into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted model
func (o *UserTemplate) create(ctx context.Context, exec bob.Executor) (context.Context, *models.User, error) {
	var err error
	opt := o.BuildSetter()
	ensureCreatableUser(opt)

	m, err := models.Users.Insert(ctx, exec, opt)
	if err != nil {
		return ctx, nil, err
	}
	ctx = userCtx.WithValue(ctx, m)

	ctx, err = o.insertOptRels(ctx, exec, m)
	return ctx, m, err
}

// CreateMany builds multiple users and inserts them into the database
// Relations objects are also inserted and placed in the .R field
func (o UserTemplate) CreateMany(ctx context.Context, exec bob.Executor, number int) (models.UserSlice, error) {
	_, m, err := o.createMany(ctx, exec, number)
	return m, err
}

// createMany builds multiple users and inserts them into the database
// Relations objects are also inserted and placed in the .R field
// this returns a context that includes the newly inserted models
func (o UserTemplate) createMany(ctx context.Context, exec bob.Executor, number int) (context.Context, models.UserSlice, error) {
	var err error
	m := make(models.UserSlice, number)

	for i := range m {
		ctx, m[i], err = o.create(ctx, exec)
		if err != nil {
			return ctx, nil, err
		}
	}

	return ctx, m, nil
}

// User has methods that act as mods for the UserTemplate
var UserMods userMods

type userMods struct{}

func (m userMods) RandomizeAllColumns(f *faker.Faker) UserMod {
	return UserModSlice{
		UserMods.RandomUserID(f),
		UserMods.RandomUsername(f),
		UserMods.RandomPasswordhash(f),
	}
}

// Set the model columns to this value
func (m userMods) UserID(val uuid.UUID) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.UserID = func() uuid.UUID { return val }
	})
}

// Set the Column from the function
func (m userMods) UserIDFunc(f func() uuid.UUID) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.UserID = f
	})
}

// Clear any values for the column
func (m userMods) UnsetUserID() UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.UserID = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m userMods) RandomUserID(f *faker.Faker) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.UserID = func() uuid.UUID {
			return random[uuid.UUID](f)
		}
	})
}

func (m userMods) ensureUserID(f *faker.Faker) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		if o.UserID != nil {
			return
		}

		o.UserID = func() uuid.UUID {
			return random[uuid.UUID](f)
		}
	})
}

// Set the model columns to this value
func (m userMods) Username(val string) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Username = func() string { return val }
	})
}

// Set the Column from the function
func (m userMods) UsernameFunc(f func() string) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Username = f
	})
}

// Clear any values for the column
func (m userMods) UnsetUsername() UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Username = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m userMods) RandomUsername(f *faker.Faker) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Username = func() string {
			return random[string](f)
		}
	})
}

func (m userMods) ensureUsername(f *faker.Faker) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		if o.Username != nil {
			return
		}

		o.Username = func() string {
			return random[string](f)
		}
	})
}

// Set the model columns to this value
func (m userMods) Passwordhash(val string) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Passwordhash = func() string { return val }
	})
}

// Set the Column from the function
func (m userMods) PasswordhashFunc(f func() string) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Passwordhash = f
	})
}

// Clear any values for the column
func (m userMods) UnsetPasswordhash() UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Passwordhash = nil
	})
}

// Generates a random value for the column using the given faker
// if faker is nil, a default faker is used
func (m userMods) RandomPasswordhash(f *faker.Faker) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.Passwordhash = func() string {
			return random[string](f)
		}
	})
}

func (m userMods) ensurePasswordhash(f *faker.Faker) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		if o.Passwordhash != nil {
			return
		}

		o.Passwordhash = func() string {
			return random[string](f)
		}
	})
}

func (m userMods) WithWatchlists(number int, related *WatchlistTemplate) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.r.Watchlists = []*userRWatchlistsR{{
			number: number,
			o:      related,
		}}
	})
}

func (m userMods) WithNewWatchlists(number int, mods ...WatchlistMod) UserMod {
	return UserModFunc(func(o *UserTemplate) {

		related := o.f.NewWatchlist(mods...)
		m.WithWatchlists(number, related).Apply(o)
	})
}

func (m userMods) AddWatchlists(number int, related *WatchlistTemplate) UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.r.Watchlists = append(o.r.Watchlists, &userRWatchlistsR{
			number: number,
			o:      related,
		})
	})
}

func (m userMods) AddNewWatchlists(number int, mods ...WatchlistMod) UserMod {
	return UserModFunc(func(o *UserTemplate) {

		related := o.f.NewWatchlist(mods...)
		m.AddWatchlists(number, related).Apply(o)
	})
}

func (m userMods) WithoutWatchlists() UserMod {
	return UserModFunc(func(o *UserTemplate) {
		o.r.Watchlists = nil
	})
}
